package eserciziArray.esercizio10;

public class Rubrica {
  /*
   * Massimo numero di contatti possibili in rubrica
   */
  public static final Integer MAX_CONTATTI = 200;
  
  private Contatto[] contatti = new Contatto[MAX_CONTATTI];
  
  
  public  Rubrica() {
	  
  }
  
 
  /**
   * Restituisce l'indice per registrare il prossimo contatto.
   * @return
   */
  private Integer getNextIndex () {
	  Integer result = 0;
	  
	  
	  result = 0;
	  for ( Contatto contatto : contatti ) {

		  if ( contatto == null ) {
			  //Caso: trovato il primo elemento vuoto dell'array contatti
			  break;
			  
		  }else {
			  result ++;
		  }
	  }

	  
	  for ( int i=0; i<contatti.length; i++ ) {
		  Contatto contatto = contatti[i];

		  if ( contatto == null ) {
			  //Caso: trovato il primo elemento vuoto dell'array contatti
			  break;
			  
		  }else {
			  result ++;
		  }
	  }
	  
	  
	  
	  return result;
  }
  
  /**
   * Numero di contatti presenti in rubrica.
   * Restituisce  -1 se la rubrica è vuota.
   * @return
   */
  private Integer getNumeroContattiPresenti() {
	  Integer result = 0;
	  
	  result = getNextIndex();
	  
	  return result;
  }
  



  
  public void aggiungiContatto(String nome, String cognome, String numero) {
	  Integer 	nextIndex = 0;
	  Contatto 	contatto  = null;
	  
	  nextIndex = getNextIndex ();
	  contatto  = new Contatto(nome, cognome, numero);
	  if ( nextIndex < MAX_CONTATTI ) {
		  //Caso : Aggiuge il contatto
		  
		  contatti[nextIndex] = contatto;
	  }else {
		  //Caso : Non registra il contatto.
		  //       Causa Rubrica piena 
		  
		  System.err.println("Rubrica Piena! Il Contatto " + contatto + " NON e' stato registrato.");
	  }
	  
  }  
  
  
  
  
  
  @Override
  public String toString() {
	StringBuffer 	result 	= new StringBuffer();
	Integer 		numeroContattiPresenti = 0;
	
	

	result.append("Rubrica"  + "\n");
	result.append("---------------------------"  + "\n");
	
	numeroContattiPresenti = getNumeroContattiPresenti();
	for ( int i=0; i<numeroContattiPresenti; i++ ) {
		result.append(contatti[i] + "\n");
	}
	
	if ( numeroContattiPresenti != -1 ) {
		//Caso: Rubrica piena (almeno un contatto)
		result.append("-- presenti " + numeroContattiPresenti  + " contatti " + "\n");
		
	} else {
		//Caso: Rubrica vuota
		//      Si segnala che la rubrica NON ha contatti
		result.append("-- Attenzione!! La Rubrica é vuota"  + "\n");
	}
	
	
	
	result.append("---------------------------"  + "\n");
			
	return result.toString();
  }
   
  
  
}
